## upx-ucl 3.08

=== Makefile ===
#
# UPX toplevel Makefile - needs GNU make 3.81 or better
#
# Copyright (C) 1996-2011 Markus Franz Xaver Johannes Oberhumer
#

MAKEFLAGS += -rR
.SUFFIXES:
export SHELL = /bin/sh

ifneq ($(findstring $(firstword $(MAKE_VERSION)),3.77 3.78 3.78.1 3.79 3.79.1 3.80),)
$(error GNU make 3.81 or better is required)
endif

srcdir = .
top_srcdir = .
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)


# info: src/stub needs special build tools
BUILD_STUB = 0
ifneq ($(wildcard $(HOME)/local/bin/bin-upx/.),)
BUILD_STUB = 1
endif
ifneq ($(wildcard $(HOME)/bin/bin-upx/.),)
BUILD_STUB = 1
endif


default:
	@echo "UPX info: please choose a target for 'make'"

all mostlyclean clean distclean maintainer-clean:
ifeq ($(BUILD_STUB),1)
	$(MAKE) -C src/stub $@
endif
	$(MAKE) -C src $@
	$(MAKE) -C doc $@


.PHONY: default all mostlyclean clean distclean maintainer-clean

=== debian/changelog ===
upx-ucl (3.08-2ubuntu1) precise; urgency=low

  * Merge from Debian testing. (LP: #928768) Remaining changes:
    - [arm] needs porting to thumb2; use -marm as the code
      does a lot of low level hacking not yet ready for thumb2 

 -- Paolo Sammicheli <xdatap1@ubuntu.com>  Thu, 19 Jan 2012 07:47:12 +0000

upx-ucl (3.08-2) unstable; urgency=low

  * Upload to unstable.
  * LZMA compression is now supported (LP: #625158).

 -- Robert Luberda <robert@debian.org>  Mon, 09 Jan 2012 00:56:10 +0100

upx-ucl (3.08-1) experimental; urgency=low

  * New upstream version 3.08.
  * Switch to tiny rules format and debhelper v9.
  * Rename & refresh patches with gbp-pq import/export.
  * Add VCS fields.

 -- Robert Luberda <robert@debian.org>  Sun, 08 Jan 2012 16:41:22 +0100

upx-ucl (3.07-3ubuntu1) oneiric; urgency=low

  * Merge from debian unstable. (LP: #799241) Remaining changes:
    - [arm] needs porting to thumb2; use -marm as the code
      does a lot of low level hacking not yet ready for thumb2

 -- Paolo Sammicheli <xdatap1@ubuntu.com>  Thu, 10 Feb 2011 04:37:58 +0000

=== debian/control ===
Source: upx-ucl
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Robert Luberda <robert@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 8.9.14~),
               libucl-dev (>= 1.03),
               lzma-dev (>= 9.22),
               zlib1g-dev (>= 1:1.1.4)
Homepage: http://upx.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/users/robert/upx-ucl.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/robert/upx-ucl.git

Package: upx-ucl
Architecture: any
Provides: upx
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: efficient live-compressor for executables
 UPX is an advanced executable file compressor. UPX will typically
 reduce the file size of programs and DLLs by around 50%-70%, thus
 reducing disk space, network load times, download times etc. The
 current version can compress executables for DOS, Linux/ELF (i386,
 amd64, ppc32) and some other files for different OS.
 .
 NOTE: This package is based on the UCL library, which is licensed under GPL.

=== debian/rules ===
#!/usr/bin/make -f

DH_AUTO_OPTIONS         := -v -Smakefile --parallel
package                 := $(shell dh_listpackages)


BIG_ENDIAN_ARCHS        := hppa ia64 sparc
DEB_BUILD_ARCH          := $(shell dpkg-architecture -qDEB_BUILD_ARCH)

export DESTDIR          := $(CURDIR)/debian/$(package)

export CC               := gcc
export CXX              := g++
export UPX_UCLDIR       := /none
export UPX_LZMADIR      := /usr/include/lzma
export CXXFLAGS         := $(shell dpkg-buildflags --get CXXFLAGS)
export CPPFLAGS         := -DWITH_UCL $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS          := $(shell dpkg-buildflags --get LDFLAGS)
ifneq (,$(findstring $(DEB_BUILD_ARCH), $(BIG_ENDIAN_ARCHS)))
        CPPFLAGS        += -D__BIG_ENDIAN__=1
endif

ifeq (0,1)
	CXXFLAGS 	+= -I $(I)
	LDFLAGS 	+= -L $(L)
endif

ifeq (armel,$(DEB_BUILD_ARCH))
	# [asac] not thumb2 ready - use -marm
	CXXFLAGS	+= -marm
endif

build: build-stamp

%:
	dh "$@"

override_dh_auto_build: build-stamp
build-stamp:
	rm -f .pc/.*unapply # see bug#649521

	# Add here commands to compile the package.
	@echo "Starting build process ($(DEB_BUILD_ARCH))"
	dh_auto_build $(DH_AUTO_OPTIONS) --     \
	              exeext=""                 \
	              target=linux              \
	              all

	cd doc && mv upx.1 $(package).1

	touch "$@"

override_dh_auto_clean:
	rm -f build-stamp

	dh_auto_clean $(DH_AUTO_OPTIONS) -- \
	                exeext=""
	rm -rf doc/*.1 doc/*.ps

override_dh_auto_install:
	install -pm 0755 src/upx $(DESTDIR)/usr/bin/$(package)

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_installman:
	dh_installman doc/*.1

## upx-ucl 3.09

=== src/stub/Makefile ===
#
# UPX stub Makefile - needs GNU make 3.81 or better
#
# You also will need a number of special build tools like various
# cross-assemblers and cross-compilers - please see README.SRC
# for details.
#
# Copyright (C) 1996-2013 Markus Franz Xaver Johannes Oberhumer
#

MAKEFLAGS += -rR
.SUFFIXES:
.SECONDEXPANSION:
.NOTPARALLEL:
export LC_ALL = C
export SHELL = /bin/sh

# internal make variables
comma := ,
empty :=
space := $(empty) $(empty)
tab   := $(empty)	$(empty)

ifneq ($(findstring $(firstword $(MAKE_VERSION)),3.77 3.78 3.78.1 3.79 3.79.1 3.80),)
$(error GNU make 3.81 or better is required)
endif

ifndef srcdir
srcdir := $(dir $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))
srcdir := $(shell echo '$(srcdir)' | sed 's,/*$$,,')
endif
ifndef top_srcdir
top_srcdir := $(srcdir)/../..
endif
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)

# update $PATH for our special stub build tools
ifneq ($(wildcard $(HOME)/local/bin/bin-upx/.),)
export PATH := $(HOME)/local/bin/bin-upx:$(PATH)
endif
ifneq ($(wildcard $(HOME)/bin/bin-upx/.),)
export PATH := $(HOME)/bin/bin-upx:$(PATH)
endif


# /***********************************************************************
# //
# ************************************************************************/

ifndef STUBS
STUBS += amd64-darwin.dylib-entry.h
STUBS += amd64-darwin.macho-entry.h
STUBS += amd64-darwin.macho-fold.h
STUBS += amd64-linux.elf-entry.h
STUBS += amd64-linux.elf-fold.h
STUBS += amd64-linux.kernel.vmlinux-head.h
STUBS += amd64-linux.kernel.vmlinux.h
STUBS += amd64-linux.shlib-init.h
STUBS += arm-darwin.macho-entry.h
STUBS += arm-darwin.macho-fold.h
STUBS += arm-linux.elf-entry.h
STUBS += arm-linux.elf-fold.h
STUBS += arm-linux.kernel.vmlinux-head.h
STUBS += arm-linux.kernel.vmlinux.h
STUBS += arm-linux.shlib-init.h
STUBS += arm.v4a-wince.pe.h
STUBS += arm.v4t-wince.pe.h
STUBS += armeb-linux.elf-entry.h
STUBS += armeb-linux.elf-fold.h
STUBS += armeb-linux.kernel.vmlinux-head.h
STUBS += armeb-linux.kernel.vmlinux.h
STUBS += armel-eabi-linux.elf-entry.h
STUBS += armel-eabi-linux.elf-fold.h
STUBS += armel-eabi-linux.shlib-init.h
STUBS += armel-linux.kernel.vmlinuz-head.h
STUBS += armel-linux.kernel.vmlinuz.h
STUBS += i086-dos16.com.h
STUBS += i086-dos16.exe.h
STUBS += i086-dos16.sys.h
STUBS += i386-bsd.elf-entry.h
STUBS += i386-bsd.elf-fold.h
STUBS += i386-bsd.elf.execve-entry.h
STUBS += i386-bsd.elf.execve-fold.h
STUBS += i386-darwin.dylib-entry.h
# STUBS += i386-darwin.dylib-fold.h
STUBS += i386-darwin.macho-entry.h
STUBS += i386-darwin.macho-fold.h
STUBS += i386-dos32.djgpp2-stubify.h
STUBS += i386-dos32.djgpp2.h
STUBS += i386-dos32.tmt.h
STUBS += i386-dos32.watcom.le.h
STUBS += i386-linux.elf-entry.h
STUBS += i386-linux.elf-fold.h
STUBS += i386-linux.elf.execve-entry.h
STUBS += i386-linux.elf.execve-fold.h
STUBS += i386-linux.elf.interp-entry.h
STUBS += i386-linux.elf.interp-fold.h
STUBS += i386-linux.elf.shell-entry.h
STUBS += i386-linux.elf.shell-fold.h
STUBS += i386-linux.kernel.vmlinux-head.h
STUBS += i386-linux.kernel.vmlinux.h
STUBS += i386-linux.kernel.vmlinuz.h
STUBS += i386-linux.shlib-init.h
STUBS += i386-netbsd.elf-entry.h
STUBS += i386-netbsd.elf-fold.h
STUBS += i386-openbsd.elf-fold.h
STUBS += i386-win32.pe.h
STUBS += m68k-atari.tos.h
STUBS += mips.r3000-linux.elf-entry.h
STUBS += mips.r3000-linux.elf-fold.h
STUBS += mipsel.r3000-linux.elf-entry.h
STUBS += mipsel.r3000-linux.elf-fold.h
STUBS += mipsel.r3000-ps1.h
STUBS += powerpc-darwin.dylib-entry.h
STUBS += powerpc-darwin.macho-entry.h
STUBS += powerpc-darwin.macho-fold.h
STUBS += powerpc-linux.elf-entry.h
STUBS += powerpc-linux.elf-fold.h
STUBS += powerpc-linux.kernel.vmlinux-head.h
STUBS += powerpc-linux.kernel.vmlinux.h
STUBS += thumb-eabi-linux.shlib-init.h
endif


ifndef default.targets
ifeq ($(wildcard .all-stamp),)
default.targets =
default:
	@echo "UPX info: type 'make all' if you have all the required build tools."
else
default.targets = all
default: $$(default.targets)
endif
endif


all.targets ?= .upx-stubtools-stamp tmp/.tmp-stamp .all-stamp
all: $$(all.targets)
.upx-stubtools-stamp: $(MAKEFILE_LIST)
	upx-stubtools-check-version 20060823
	@echo "timestamp" > $@
%/.tmp-stamp:
	@mkdir -p $(dir $@)
	@echo "timestamp" > $@
.PRECIOUS: %/.tmp-stamp
.all-stamp: $$(STUBS)
	@echo "timestamp" > $@

ifeq ($(wildcard .all-stamp),)
mostlyclean clean: distclean
else
mostlyclean clean: maintainer-clean
endif
distclean:
	rm -f .*-stamp
	rm -rf tmp
maintainer-clean:
	rm -f .upx-stubtools-stamp
	rm -rf tmp
	rm -f $(STUBS)

.PHONY: default all mostlyclean clean distclean maintainer-clean


# util var for use in the rules - basename of the current target
override T = $(basename $(notdir $@))

# clear some vars, just in case
LABEL_PREFIX =
PP_FLAGS =
tc_bfdarch =
tc_bfdname =
tc_list =
tc_objdump_disasm_options =

# commands
ECHO_e     = /bin/echo -e
ECHO_E     = /bin/echo -E
PERL       = perl
PYTHON     = python
UNIX2DOS  := $(PERL) -i -pe 's/$$/\r/;'

# trim (strip) trailing whitespace
RTRIM     := sed -e 's/[ $(tab)]*$$//'
# squeeze duplicate blank lines, delete empty first & last line
BLSQUEEZE := $(RTRIM) | cat --squeeze-blank | sed -e '1{/^$$/d}' -e '$${/^$$/d}'
# delete blank lines
BLDEL     := $(RTRIM) | sed -e '/^$$/d'
# delete blank lines at top (beginning) of file
BLDELTOP  := sed -e '/./,$$!d'
# delete blank lines at bottom (end) of file
BLDELBOT  := sed -e ':a' -e '/^\n*$$/{$$d;N;ba' -e '}'


# /***********************************************************************
# // setup toolchain globals
# ************************************************************************/

# enumerate the names of all variables that will get tested (from basename and $(tc_list))
__tc_varlist   = tc.$(basename $(notdir $@)).$1 $(foreach v,$(tc_list),tc.$v.$1)
# return the name of the first variable that is not empty
__tc_varsearch = $(firstword $(foreach v,$1,$(if $($v),$v,)))
# error sentinel for missing commands
__tc_FALSE     = false tc_FALSE: '1:$1 2:$2 3:$3 4:$4 5:$5' '$@' '$<' '$(tc_list)'
# call (expand) the first variable that is not empty
  # [move the next comment line within the "tc" macro for debugging]
  # tc debug '1:$1 2:$2 3:$3 4:$4 5:$5' '$@' '$<' '$(tc_list)'
define tc
  $(call $(call __tc_varsearch,$(call __tc_varlist,$1) __tc_FALSE),$2,$3,$4,$5)
endef

# default tools
tc.default.bin2h      = $(PYTHON) $(top_srcdir)/src/stub/scripts/bin2h.py --ident=auto-stub
##tc.default.bin2h-c    = $(call tc,bin2h) --compress=14,15,0
tc.default.bin2h-c    = $(call tc,bin2h) --compress=0
tc.default.brandelf   = $(PYTHON) $(top_srcdir)/src/stub/scripts/brandelf.py $(if $(tc_bfdname),--bfdname=$(tc_bfdname))
tc.default.gpp_inc    = $(PYTHON) $(top_srcdir)/src/stub/scripts/gpp_inc.py
tc.default.gpp_mkdep  = $(PYTHON) $(top_srcdir)/src/stub/scripts/gpp_inc.py -o /dev/null
tc.default.pp-as      = i386-linux-gcc-3.4.6 -E -nostdinc -x assembler-with-cpp -Wall
tc.default.sstrip     = sstrip
tc.default.xstrip     = $(PYTHON) $(top_srcdir)/src/stub/scripts/xstrip.py

# default multiarch-binutils
tc.default.m-ar       = multiarch-ar-2.17
tc.default.m-ld       = multiarch-ld-2.17 $(if $(tc_bfdname),-b $(tc_bfdname))
tc.default.m-nm       = multiarch-nm-2.17 $(if $(tc_bfdname),--target=$(tc_bfdname))
tc.default.m-objcopy  = multiarch-objcopy-2.17 $(if $(tc_bfdname),-F $(tc_bfdname))
tc.default.m-objdump  = multiarch-objdump-2.17 $(if $(tc_bfdname),-b $(tc_bfdname)) $(if $(tc_bfdarch),-m $(tc_bfdarch))
tc.default.m-readelf  = multiarch-readelf-2.17

# default binutils
tc.default.ld         = $(call tc,m-ld)
tc.default.nm         = $(call tc,m-nm)
tc.default.objcopy    = $(call tc,m-objcopy)
tc.default.objdump    = $(call tc,m-objdump)
tc.default.readelf    = $(call tc,m-readelf)

# default binutils functions
define tc.default.f-embed_objinfo
	chmod a-x $1
	$(call tc,objcopy) --strip-unneeded $1
	$(call tc,objcopy) -R .text -R .data -R .bss $1
	$(call tc,objcopy) -R .comment -R .note -R .note.GNU-stack -R .reginfo $1
	$(call tc,objdump) -Dr $(tc_objdump_disasm_options) $1 | $(RTRIM) > $1.disasm
	$(call tc,objdump) -htr -w $1 | $(BLSQUEEZE) | sed -e '1s/^.*: *file format/file format/' > $1.dump
	$(call tc,xstrip) --with-dump=$1.dump --create-bindump=$1.bindump $1
	cat $1.dump >> $1
endef
define tc.default.f-objstrip
	chmod a-x $1
	$(call tc,objcopy) -R .comment -R .note -R .note.GNU-stack -R .reginfo $1
endef

# some common arch settings
tc.arch-i086.gcc      = i386-linux-gcc-3.4.6 -m32 -march=i386 -nostdinc -MMD -MT $@
tc.arch-i086.wdis     = $(WATCOM)/binl/wdis
tc.arch-i386.gcc      = i386-linux-gcc-3.4.6 -m32 -march=i386 -nostdinc -MMD -MT $@
tc.arch-i386.djasm    = djasm


# /***********************************************************************
# // amd64-darwin.dylib
# ************************************************************************/

# info: we use the tc settings from amd64-linux.elf
amd64-darwin.dylib%.h : tc_list = amd64-linux.elf default
amd64-darwin.dylib%.h : tc_bfdname = elf64-x86-64

## All code is in dylib-entry.  There is no dylib-fold, no dylib-main.
amd64-darwin.dylib-entry.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h) tmp/$T.bin $@


# /***********************************************************************
# // amd64-darwin.macho
# ************************************************************************/

# info: we use the tc settings from amd64-linux.elf
amd64-darwin.macho%.h : tc_list = amd64-linux.elf default
amd64-darwin.macho%.h : tc_bfdname = elf64-x86-64

amd64-darwin.macho-entry.h : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h) tmp/$T.bin $@

amd64-darwin.macho-fold.h : tmp/$$T.o tmp/amd64-darwin.macho-main.o
	$(call tc,ld) --no-warn-mismatch --strip-all --oformat binary -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
	chmod a-x tmp/$T.bin
	$(call tc,bin2h) tmp/$T.bin $@

tmp/amd64-darwin.macho-fold.o : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o $@
	$(call tc,f-objstrip,$@)

tmp/amd64-darwin.macho-main.o : $(srcdir)/src/$$T.c
	$(call tc,gcc) -c -Os -fPIC $< -o $@
	$(call tc,f-objstrip,$@)
	$(call tc,objdump) -dr $(tc_objdump_disasm_options) $@ | $(RTRIM) > $@.disasm


# /***********************************************************************
# // amd64-linux.elf
# ************************************************************************/

amd64-linux.elf%.h : tc_list = amd64-linux.elf default
amd64-linux.elf%.h : tc_bfdname = elf64-x86-64

tc.amd64-linux.elf.gcc  = amd64-linux-gcc-3.4.4 -m64 -nostdinc -MMD -MT $@
tc.amd64-linux.elf.gcc += -fno-exceptions -fno-asynchronous-unwind-tables
tc.amd64-linux.elf.gcc += -Wall -W -Wcast-align -Wcast-qual -Wstrict-prototypes -Wwrite-strings -Werror

amd64-linux.elf-entry.h: $(srcdir)/src/$$T.S
	$(call tc,gcc) -c -x assembler-with-cpp $< -o tmp/$T.bin
	$(call tc,f-embed_objinfo,tmp/$T.bin)
	$(call tc,bin2h) tmp/$T.bin $@

amd64-linux.elf-fold.h : tmp/$$T.o tmp/amd64-linux.elf-main.o $(srcdir)/src/$$T.lds
#	# FIXME: multiarch-ld-2.18 creates a huge file here, so use 2.17
#	####$(call tc,ld) --strip-all -T $(srcdir)/src/$T.lds -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
	multiarch-ld-2.17 --strip-all -T $(srcdir)/src/$T.lds -Map tmp/$T.map $(filter %.o,$^) -o tmp/$T.bin
	$(call tc,f-objstrip,tmp/$T.bin)
	$(call tc,sstrip) tmp/$T.bin
	$(call tc,bin2h) tmp/$T.bin $@

tmp/amd64-linux.elf-fold.o : $(srcdir)/src/$$T.S
	$(call tc,gcc) -c $< -o $@
	$(call tc,f-objstrip,$@)

tmp/amd64-linux.elf-main.o : $(srcdir)/src/$$T.c
	$(call tc,gcc) -c -Os $< -o $@
	$(call tc,f-objstrip,$@)
	$(call tc,objdump) -dr $(tc_objdump_disasm_options) $@ | $(RTRIM) > $@.disasm


# /***********************************************************************
# // amd64-linux.kernel.vmlinux
# // amd64-linux.kernel.vmlinux-head
# ************************************************************************/

# info: we use the tc settings from arch-i386 !!

=== debian/changelog ===
upx-ucl (3.09-2ubuntu1) saucy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/rules: [arm] needs porting to thumb2; use -marm as the code
      does a lot of low level hacking not yet ready for thumb2.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 11 May 2013 15:26:07 -0400

upx-ucl (3.09-2) unstable; urgency=low

  * Upload to unstable.
  * Standard-Version: 3.9.4:
    + add Built-Using field referring to version of lzma-dev package.

 -- Robert Luberda <robert@debian.org>  Fri, 10 May 2013 09:18:12 +0200

upx-ucl (3.09-1) experimental; urgency=low

  * New upstream version 3.09:
    + g++-4.8 compilation issue fixed by upstream (closes: #701368).
  * Compile with -D_FILE_OFFSET_BITS=64 to fix `file not found'
    error on Windows samba shares (closes: #698029).
  * Bump Standards-Version to 3.9.3 (no changes required).

 -- Robert Luberda <robert@debian.org>  Sun, 24 Mar 2013 11:03:52 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Robert Luberda <robert@debian.org>
-Standards-Version: 3.9.2
-Build-Depends: debhelper (>= 8.9.14~),
+Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9),
                libucl-dev (>= 1.03),
                lzma-dev (>= 9.22),
                zlib1g-dev (>= 1:1.1.4)
@@ -14,6 +14,7 @@
 
 Package: upx-ucl
 Architecture: any
+Built-Using: ${Built-Using}
 Provides: upx
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: efficient live-compressor for executables

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 DH_AUTO_OPTIONS         := -v -Smakefile --parallel
+BUILT_USING             := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W lzma-dev)
 package                 := $(shell dh_listpackages)
 
 
@@ -14,7 +15,8 @@
 export UPX_UCLDIR       := /none
 export UPX_LZMADIR      := /usr/include/lzma
 export CXXFLAGS         := $(shell dpkg-buildflags --get CXXFLAGS)
-export CPPFLAGS         := -DWITH_UCL $(shell dpkg-buildflags --get CPPFLAGS)
+export CPPFLAGS         := -DWITH_UCL -D_FILE_OFFSET_BITS=64 \
+                           $(shell dpkg-buildflags --get CPPFLAGS)
 export LDFLAGS          := $(shell dpkg-buildflags --get LDFLAGS)
 ifneq (,$(findstring $(DEB_BUILD_ARCH), $(BIG_ENDIAN_ARCHS)))
         CPPFLAGS        += -D__BIG_ENDIAN__=1
@@ -65,3 +67,6 @@
 
 override_dh_installman:
 	dh_installman doc/*.1
+
+override_dh_gencontrol:
+	dh_gencontrol -- -VBuilt-Using="$(BUILT_USING)"

## upx-ucl 3.91

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # UPX toplevel Makefile - needs GNU make 3.81 or better
 #
-# Copyright (C) 1996-2011 Markus Franz Xaver Johannes Oberhumer
+# Copyright (C) 1996-2013 Markus Franz Xaver Johannes Oberhumer
 #
 
 MAKEFLAGS += -rR

=== src/Makefile ===
#
# UPX Makefile - needs GNU make 3.81 or better
#
# Copyright (C) 1996-2013 Markus Franz Xaver Johannes Oberhumer
#

MAKEFLAGS += -rR
.SUFFIXES:
export SHELL = /bin/sh
override e = $($1) $(EXTRA_$1) $(upx_$1) $($(basename $(notdir $@)).$1)

ifneq ($(findstring $(firstword $(MAKE_VERSION)),3.77 3.78 3.78.1 3.79 3.79.1 3.80),)
$(error GNU make 3.81 or better is required)
endif

ifndef srcdir
srcdir := $(dir $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))
srcdir := $(shell echo '$(srcdir)' | sed 's,/*$$,,')
endif
ifndef top_srcdir
top_srcdir := $(srcdir)/..
endif
include $(wildcard $(top_srcdir)/Makevars.global ./Makevars.local)
ifneq ($(srcdir),.)
##$(info Info: using VPATH . $(srcdir))
VPATH := . $(srcdir)
endif

ifeq ($(CXX),)
CXX = g++
endif
ifneq ($(findstring $(firstword $(CXX)),g++),)
USE_GNUC ?= 1
endif
ifeq ($(USE_GNUC),1)
ifeq ($(DEBUG),1)
CXXFLAGS += -O0 -g
else
CXXFLAGS += -O2
endif
CXXFLAGS_WERROR = -Werror
CXXFLAGS += -Wall -W -Wcast-align -Wcast-qual -Wpointer-arith -Wshadow -Wwrite-strings
CXXFLAGS += $(CXXFLAGS_WERROR)
endif
CPPFLAGS += $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES)
CXXLD ?= $(CXX)

exeext ?= .out
libext ?= .a
objext ?= .o

upx_SOURCES := $(sort $(wildcard $(srcdir)/*.cpp))
upx_OBJECTS := $(notdir $(upx_SOURCES:.cpp=$(objext)))

# we need UCL and zlib - you can set envvar UPX_UCLDIR
ifneq ($(wildcard $(UPX_UCLDIR)/include/ucl/ucl.h),)
INCLUDES += -I$(UPX_UCLDIR)/include
LIBS += $(addprefix -L,$(dir $(wildcard $(UPX_UCLDIR)/libucl$(libext) $(UPX_UCLDIR)/src/.libs/libucl$(libext))))
endif
LIBS += -lucl -lz
# you should set envvar UPX_LZMADIR to point to your unpacked LZMA SDK
include $(top_srcdir)/src/stub/src/c/Makevars.lzma
ifneq ($(UPX_LZMA_VERSION),)
DEFS += -DWITH_LZMA=$(UPX_LZMA_VERSION)
INCLUDES += -I$(UPX_LZMADIR)
endif


all: upx$(exeext) | .depend
.DELETE_ON_ERROR: upx$(exeext) $(upx_OBJECTS) .depend

upx$(exeext): $(upx_OBJECTS) $(upx_DEPENDENCIES)
	$($(notdir $@).PRE_LINK_STEP)
	$(strip $(CXXLD) $(call e,CPPFLAGS) $(call e,CXXFLAGS) $(call e,LDFLAGS) -o $@ $(upx_OBJECTS) $(call e,LDADD) $(call e,LIBS))
	$($(notdir $@).POST_LINK_STEP)

%.o : %.cpp | .depend
	$(strip $(CXX) $(call e,CPPFLAGS) $(call e,CXXFLAGS) -o $@ -c $<)

.depend: $(sort $(wildcard $(srcdir)/*.cpp $(srcdir)/*.h)) $(MAKEFILE_LIST)
	@rm -f $@
ifeq ($(USE_GNUC),1)
	@echo "Updating $@"
	@$(strip $(CXX) $(call e,CPPFLAGS) -MM) $(filter %.cpp,$^) > $@
else
	touch $@
endif


ifeq ($(USE_GNUC),1)
##compress_lzma$(objext) : CXXFLAGS += -O3 -fomit-frame-pointer
compress_lzma$(objext) : CXXFLAGS += -Wno-cast-qual
compress_lzma$(objext) : CXXFLAGS += -Wno-shadow
ifeq ($(UPX_LZMA_VERSION),0x443)
compress_lzma$(objext) : CXXFLAGS += -Wno-non-virtual-dtor
compress_lzma$(objext) : CXXFLAGS += -Wno-unused
endif
# needed for gcc-4.3:
compress_lzma$(objext) : CXXFLAGS += -Wno-error
endif


mostlyclean clean distclean maintainer-clean:
	rm -f *.d *.map *.o *.obj *.res .depend upx.exe upx.out upx.ttp upx$(exeext)

.PHONY: all mostlyclean clean distclean maintainer-clean

ifeq ($(MAKECMDGOALS),mostlyclean)
else ifeq ($(MAKECMDGOALS),clean)
else ifeq ($(MAKECMDGOALS),distclean)
else ifeq ($(MAKECMDGOALS),maintainer-clean)
else
-include .depend
endif

=== src/stub/Makefile ===
--- 
+++ 
@@ -56,6 +56,7 @@
 STUBS += amd64-linux.kernel.vmlinux-head.h
 STUBS += amd64-linux.kernel.vmlinux.h
 STUBS += amd64-linux.shlib-init.h
+STUBS += amd64-win64.pep.h
 STUBS += arm-darwin.macho-entry.h
 STUBS += arm-darwin.macho-fold.h
 STUBS += arm-linux.elf-entry.h
@@ -137,7 +138,7 @@
 all.targets ?= .upx-stubtools-stamp tmp/.tmp-stamp .all-stamp
 all: $$(all.targets)
 .upx-stubtools-stamp: $(MAKEFILE_LIST)
-	upx-stubtools-check-version 20060823
+	upx-stubtools-check-version 20130920
 	@echo "timestamp" > $@
 %/.tmp-stamp:
 	@mkdir -p $(dir $@)
@@ -246,9 +247,14 @@
 	$(call tc,xstrip) --with-dump=$1.dump --create-bindump=$1.bindump $1
 	cat $1.dump >> $1
 endef
+
+tc.default.f-objstrip-disasm.bin = @true
+tc.default.f-objstrip-disasm.o   = $(call tc,objdump) -dr $(tc_objdump_disasm_options) $1 | $(RTRIM) > $1.disasm
+tc.default.f-objstrip-disasm.obj = $(call tc,objdump) -dr $(tc_objdump_disasm_options) $1 | $(RTRIM) > $1.disasm
 define tc.default.f-objstrip
 	chmod a-x $1
 	$(call tc,objcopy) -R .comment -R .note -R .note.GNU-stack -R .reginfo $1
+	$(call tc,f-objstrip-disasm$(suffix $1),$1)
 endef
 
 # some common arch settings
@@ -298,7 +304,6 @@
 tmp/amd64-darwin.macho-main.o : $(srcdir)/src/$$T.c
 	$(call tc,gcc) -c -Os -fPIC $< -o $@
 	$(call tc,f-objstrip,$@)
-	$(call tc,objdump) -dr $(tc_objdump_disasm_options) $@ | $(RTRIM) > $@.disasm
 
 
 # /***********************************************************************
@@ -332,13 +337,7 @@
 tmp/amd64-linux.elf-main.o : $(srcdir)/src/$$T.c
 	$(call tc,gcc) -c -Os $< -o $@
 	$(call tc,f-objstrip,$@)
-	$(call tc,objdump) -dr $(tc_objdump_disasm_options) $@ | $(RTRIM) > $@.disasm
 
 
 # /***********************************************************************
 # // amd64-linux.kernel.vmlinux
-# // amd64-linux.kernel.vmlinux-head
-# ************************************************************************/
-
-# info: we use the tc settings from arch-i386 !!
-

=== src/stub/tools/armpe/Makefile ===
#  Makefile for armpe_tester

MAKEFLAGS += -rR
.SUFFIXES:
.SECONDEXPANSION:
.NOTPARALLEL:
export LC_ALL = C
export SHELL = /bin/sh

# update $PATH for our special stub build tools
ifneq ($(wildcard $(HOME)/local/bin/bin-upx/.),)
export PATH := $(HOME)/local/bin/bin-upx:$(PATH)
endif
ifneq ($(wildcard $(HOME)/bin/bin-upx/.),)
export PATH := $(HOME)/bin/bin-upx:$(PATH)
endif

CFLAGS_W = -Wall -W -Wcast-align -Wcast-qual -Wwrite-strings


all: armpe_tester.out
#all: armpe_tester.exe

armpe_tester.out: armpe_tester.c $(MAKEFILE_LIST)
	arm-linux-gcc-4.1.0 -Wl,--section-start,.interp=0x1000 -g $(CFLAGS_W) -o $@ $<

armpe_tester.exe: armpe_tester.c $(MAKEFILE_LIST)
	arm-wince-pe-gcc -Wl,--image-base,0x400000 -s $(CFLAGS_W) -o $@ $<

mostlyclean clean distclean maintainer-clean:
	rm -f *.d *.o *.obj
	rm -f armpe_tester.exe armpe_tester.out

.PHONY: all mostlyclean clean distclean maintainer-clean

=== debian/changelog ===
upx-ucl (3.91-1) unstable; urgency=low

  * New upstream version with experimental support for Windows 64-bit
    PE files.

 -- Robert Luberda <robert@debian.org>  Sun, 20 Oct 2013 12:27:21 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: upx-ucl
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Robert Luberda <robert@debian.org>
+Maintainer: Robert Luberda <robert@debian.org>
 Standards-Version: 3.9.4
 Build-Depends: debhelper (>= 9),
                libucl-dev (>= 1.03),

=== debian/rules ===
--- 
+++ 
@@ -22,17 +22,6 @@
         CPPFLAGS        += -D__BIG_ENDIAN__=1
 endif
 
-ifeq (0,1)
-	CXXFLAGS 	+= -I $(I)
-	LDFLAGS 	+= -L $(L)
-endif
-
-ifeq (armel,$(DEB_BUILD_ARCH))
-	# [asac] not thumb2 ready - use -marm
-	CXXFLAGS	+= -marm
-endif
-
-build: build-stamp
 
 %:
 	dh "$@"

=== debian/watch ===
# control file for the uscan(1) tool
version=2
http://upx.sourceforge.net/ \
	(?:.*/)upx-([\d\.]+)-src\.tar\.(gz|bz2)
